struct NStepAlgorithm{P,A} <: Algorithm{P}
    problem::P
    parent::A
    n::Int
end

NStepAlgorithm(alg::Algorithm, n::Int) = NStepAlgorithm(alg.problem, alg, n)

struct NStepState{A,S} <: State
    algorithm::A
    parent::S
end

Base.parent(x::NStepAlgorithm) = x.parent
Base.parent(x::NStepState) = x.parent

init(x::NStepAlgorithm) = NStepState(x, init(parent(x)))
function step!(st::NStepState)
    for i in 1:st.algorithm.n
        step!(parent(st))
    end
    return parent(st)
end
fetch(x::NStepState) = fetch(parent(x))
